package com.franckbarbier.History;

public class History {

    private com.pauware.pauware_engine.Core.AbstractState _A;
    private com.pauware.pauware_engine.Core.AbstractState _B;
    private com.pauware.pauware_engine.Core.AbstractState _C;
    private com.pauware.pauware_engine.Core.AbstractState _D;
    private com.pauware.pauware_engine.Core.AbstractState _E;
    private com.pauware.pauware_engine.Core.AbstractState _F;
    private com.pauware.pauware_engine.Core.AbstractState _G;
    private com.pauware.pauware_engine.Core.AbstractState _H;
    private com.pauware.pauware_engine.Core.AbstractStateMachine _History_state_machine;

    private void init_structure() throws com.pauware.pauware_engine.Exceptions.State_exception {
    }

    private void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _C = new com.pauware.pauware_engine.Core.State("C");
        _C.inputState();
        _D = new com.pauware.pauware_engine.Core.State("D");
        _A = _C.xor(_D).name("A");
        _A.inputState();
        _G = new com.pauware.pauware_engine.Core.State("G");
        _G.inputState();
        _H = new com.pauware.pauware_engine.Core.State("H");
        _E = _G.xor(_H).name("E");
        _F = new com.pauware.pauware_engine.Core.State("F");
        _B = _E.and(_F).name("B");
        _History_state_machine = new com.pauware.pauware_engine.Core.StateMachine(_A.xor(_B), "History", com.pauware.pauware_engine.Core.AbstractStateMachine.Don_t_show_on_system_out, new com.pauware.pauware2web.PauWare2Web_client());

        /**
         * For testing purposes, '_A.shallow_history();' can be uncommented
         * while '_History_state_machine.deep_history();' can be commented (and
         * vice versa):
         */
        _A.shallow_history();
        // _History_state_machine.deep_history();
    }

    public void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _History_state_machine.fires("from A to B", _A, _B);
        _History_state_machine.fires("from B to A", _B, _A);
        _History_state_machine.fires("from C to D", _C, _D);
        _History_state_machine.fires("from G to H", _G, _H);
        _History_state_machine.start();
    }

    public void stop() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _History_state_machine.stop();
    }

    public History() throws com.pauware.pauware_engine.Exceptions.State_exception {
        init_structure();
        init_behavior();
    }

    /**
     * UML events
     */
    public void from_A_to_B() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _History_state_machine.run_to_completion("from A to B");
    }

    public void from_B_to_A() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _History_state_machine.run_to_completion("from B to A");
    }

    public void from_C_to_D() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _History_state_machine.run_to_completion("from C to D");
    }

    public void from_G_to_H() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _History_state_machine.run_to_completion("from G to H");
    }

    public static void main(String args[]) {
        try {
            History h = new History();
            h.start();
            // for (int i = 0; i < 2; i++) {
            h.from_A_to_B(); // -> G in E in B // F
            h.from_G_to_H(); // -> H in E in B // F
            h.from_B_to_A(); // -> C in A
            h.from_C_to_D(); // -> D in A
            // If '_History_state_machine.deep_history();' then H else G
            h.from_A_to_B(); // -> (H in E in B // F) or (G in E in B // F)
            // If '_History_state_machine.deep_history();' then D else C
            h.from_B_to_A();
            // }
            h.stop();
        } catch (Throwable t) {
            t.printStackTrace();
        }
    }
}
